Bug 998645

Summary: Add support for EJB response times in EAP6
Product: [Other] RHQ Project Reporter: Lukas Krejci <lkrejci>
Component: PluginsAssignee: Lukas Krejci <lkrejci>
Status: CLOSED CURRENTRELEASE QA Contact: Mike Foley <mfoley>
Severity: high Docs Contact:
Priority: medium    
Version: 4.9CC: ccrouch, hrupp, lkrejci, loleary, myarboro
Target Milestone: ---Keywords: FutureFeature
Target Release: RHQ 4.10   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of: PRODMGT-277/PRODMGT-409 Environment:
Last Closed: 2014-04-23 08:30:15 EDT Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 911117, 913672    
Bug Blocks:    

Description Lukas Krejci 2013-08-19 12:48:04 EDT
+++ This bug was initially created as a clone of Bug #913672 +++

When https://bugzilla.redhat.com/show_bug.cgi?id=911117 is completed we should update our EAP6 plugin to take advantage

This is coming from https://issues.jboss.org/browse/PRODMGT-277

--- Additional comment from Charles Crouch on 2013-02-21 13:51:49 EST ---

Obviously this is only feasible in 3.2 if its already available in a released version of EAP6

--- Additional comment from Charles Crouch on 2013-02-21 13:55:18 EST ---

From RFE review meeting with larry and alan:

"Engineering will create a BZ to track this and potentially get it into 3.2 but we won't add this to the PRD as a requirement and the feature will be implemented if time permits (and EAP provides the capability)."

--- Additional comment from Charles Crouch on 2013-04-11 17:15:46 EDT ---

Dropping priority since based on Comment2 this is not a high priority feature. As I said there if we have time we'll look to address it.

--- Additional comment from Larry O'Leary on 2013-05-24 16:01:11 EDT ---

Looks like some of these metrics have now made it into JBoss EAP 6.1 but some data may be missing based on https://bugzilla.redhat.com/show_bug.cgi?id=911117#c8.

--- Additional comment from Lukas Krejci on 2013-06-06 07:21:35 EDT ---

EAP 6.1.0 contains the invocation statistics for individual methods on all kinds of enterprise beans.

Namely, it can report (on per-method basis):
"execution-time" - Time spend within this bean method.
"invocations" - Number of invocations processed.
"wait-time" - Time spend waiting to obtain an instance.

While investigating the metrics published by EAP, I found several that are missing from our plugin descriptor (even though they were present even in AS 7.1.1 times).

For all enterprise bean types, we do not track the following:
"peek-concurrent-invocations" - Peak concurrent invocations.
"invocations" - Number of invocations processed.
"wait-time" - Time spend waiting to obtain an instance.
"execution-time" - Time spend within a bean method.

Peek concurrent invocations seems to be like a good metric to collect (in a trendsup manner, so that we get the time derivative, which is the useful stuff). The rest of those seem to just be the aggregates of the per-method variants.

Not sure why we are not collecting these. Maybe they weren't working before, or we simply thought them not useful or just omitted them.

I will try to add them all and see what are the results with AS 7.1.1 and EAP 6.1.0.
Comment 1 Lukas Krejci 2013-09-13 08:00:39 EDT
commit d90508b9106673c06596e648e73afe4ba16da775
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Thu Sep 12 13:06:14 2013 +0200

    [BZ 998645] - Collect method invocation stats on AS7 EJBs.
Comment 2 Lukas Krejci 2013-09-18 06:59:53 EDT
I somehow managed to not push the above commit to the repository.

The correct commit hash is:

7fa1c742509e1aa365abd62f272a17e9edef7cbf
Comment 3 Lukas Krejci 2013-11-13 10:53:58 EST
commit 3382132cfe70dd0997960a25f2d8234d9c2ec553
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Wed Nov 13 16:51:57 2013 +0100

    [BZ 998645] - AS7 EJB invocation stats
    
    Now correctly react on server restart. We need to ignore the values from
    the previous collection in case we detect the server restarted, because
    after the server restart, the counting starts over from the zero again.
Comment 4 Lukas Krejci 2013-11-14 11:12:16 EST
commit 71f90566f8fd42f09e01551d34020da33d21f60f
Author: Lukas Krejci <lkrejci@redhat.com>
Date:   Thu Nov 14 17:11:19 2013 +0100

    [BZ 998645] - Don't spam the agent.log if the AS7 server doesn't support
    EJB method stats.
Comment 5 Heiko W. Rupp 2014-04-23 08:30:15 EDT
Bulk closing of 4.10 issues.

If an issue is not solved for you, please open a new BZ (or clone the existing one) with a version designator of 4.10.